﻿using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Data;
using System.Configuration;
using System.Web.Security;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;
using System.Collections.Generic;
using System.Text;

public partial class RadGridFilterSelectionMultiX : System.Web.UI.Page
{
    protected void RadGrid1_ItemCreated(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridFilteringItem)
        {
            GridFilteringItem filterItem = e.Item as GridFilteringItem;
            TableCell cell = filterItem["ShipCountry"] as TableCell;
            cell.Controls[0].Visible = false;

            RadComboBox combo = new RadComboBox();
            combo.ID = "RadComboBoxCountry";
            combo.DataSourceID = "SqlDataSource2";
            combo.DataValueField = "ShipCountry";
            combo.DataTextField = "ShipCountry";
            combo.CheckBoxes = true;
            combo.EmptyMessage = "Select Country";
            combo.Skin = RadGrid1.Skin;

            cell.Controls.AddAt(1, combo);
        }
    }
    protected void RadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridFilteringItem)
        {
            RadComboBox combo = (e.Item as GridFilteringItem).FindControl("RadComboBoxCountry") as RadComboBox;
            if (ViewState["Countries"] != null)
            {
                foreach (string country in (List<string>)ViewState["Countries"])
                {
                    combo.FindItemByText(country).Checked = true;
                }
            }
        }
    }
    bool isFiltered = false;
    protected void RadGrid1_ItemCommand(object sender, GridCommandEventArgs e)
    {
        if (e.CommandName == RadGrid.FilterCommandName)
        {
            isFiltered = true;

            Pair filterDetails = e.CommandArgument as Pair;
            string filteredColumn = filterDetails.Second.ToString();
            if (filteredColumn == "ShipCountry")
            {
                e.Canceled = true;
                GridFilteringItem filterItem = e.Item as GridFilteringItem;
                RadComboBox combo = filterItem.FindControl("RadComboBoxCountry") as RadComboBox;

                List<string> expressions = new List<string>();
                List<string> countries = new List<string>();
                if (filterDetails.First.ToString() == "NoFilter")
                {
                    expressions.Clear();
                }
                else
                {
                    foreach (RadComboBoxItem item in combo.CheckedItems)
                    {
                        countries.Add(item.Text);
                        GridColumn column = RadGrid1.MasterTableView.GetColumnSafe(filteredColumn) as GridColumn;
                        column.CurrentFilterValue = item.Value;
                        column.CurrentFilterFunction = (GridKnownFunction)Enum.Parse(typeof(GridKnownFunction), filterDetails.First.ToString());
                        expressions.Add("(" + column.EvaluateFilterExpression() + ")");
                    }
                }
                string value = string.Join("OR", expressions);
                ViewState["CountryFilterValue"] = string.IsNullOrEmpty(value) ? value : "(" + value + ")";
                ViewState["Countries"] = countries;
            }
        }
    }
    protected void RadGrid1_PreRender(object sender, EventArgs e)
    {
        if (isFiltered)
        {
            string[] expressions = RadGrid1.MasterTableView.FilterExpression.Split(new string[] { "AND" }, StringSplitOptions.None);
            List<string> columnExpressions = new List<string>(expressions);
            foreach (string expression in columnExpressions)
            {
                if (expression.Contains("[\"ShipCountry\"]"))
                {
                    columnExpressions.Remove(expression);
                    break;
                }
            }
            string finalExpression = string.Join("AND", columnExpressions);
            string countryFilterValue = (string)ViewState["CountryFilterValue"];
            if (!string.IsNullOrEmpty(countryFilterValue))
            {
                if (!string.IsNullOrEmpty(finalExpression))
                {
                    finalExpression += " AND ";
                }
                finalExpression += countryFilterValue;
            }
            RadGrid1.MasterTableView.FilterExpression = finalExpression;
            RadGrid1.MasterTableView.Rebind();
        }
    }
}
